# coding: utf-8

"""
    Cloudera Edge Flow Manager REST API

    This REST API provides remote access to the EFM Server.                                             Endpoints that are marked as [BETA] are subject to change in future releases of the application without backwards compatibility and without a major version change.

    OpenAPI spec version: 1.0.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Bundle(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'group': 'str',
        'artifact': 'str',
        'version': 'str',
        'component_manifest': 'ComponentManifest'
    }

    attribute_map = {
        'group': 'group',
        'artifact': 'artifact',
        'version': 'version',
        'component_manifest': 'componentManifest'
    }

    def __init__(self, group=None, artifact=None, version=None, component_manifest=None):
        """
        Bundle - a model defined in Swagger
        """

        self._group = None
        self._artifact = None
        self._version = None
        self._component_manifest = None

        self.group = group
        self.artifact = artifact
        if version is not None:
          self.version = version
        if component_manifest is not None:
          self.component_manifest = component_manifest

    @property
    def group(self):
        """
        Gets the group of this Bundle.
        The group id of the bundle

        :return: The group of this Bundle.
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this Bundle.
        The group id of the bundle

        :param group: The group of this Bundle.
        :type: str
        """
        if group is None:
            raise ValueError("Invalid value for `group`, must not be `None`")

        self._group = group

    @property
    def artifact(self):
        """
        Gets the artifact of this Bundle.
        The artifact id of the bundle

        :return: The artifact of this Bundle.
        :rtype: str
        """
        return self._artifact

    @artifact.setter
    def artifact(self, artifact):
        """
        Sets the artifact of this Bundle.
        The artifact id of the bundle

        :param artifact: The artifact of this Bundle.
        :type: str
        """
        if artifact is None:
            raise ValueError("Invalid value for `artifact`, must not be `None`")

        self._artifact = artifact

    @property
    def version(self):
        """
        Gets the version of this Bundle.
        The version of the bundle artifact

        :return: The version of this Bundle.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this Bundle.
        The version of the bundle artifact

        :param version: The version of this Bundle.
        :type: str
        """

        self._version = version

    @property
    def component_manifest(self):
        """
        Gets the component_manifest of this Bundle.
        The full specification of the bundle contents

        :return: The component_manifest of this Bundle.
        :rtype: ComponentManifest
        """
        return self._component_manifest

    @component_manifest.setter
    def component_manifest(self, component_manifest):
        """
        Sets the component_manifest of this Bundle.
        The full specification of the bundle contents

        :param component_manifest: The component_manifest of this Bundle.
        :type: ComponentManifest
        """

        self._component_manifest = component_manifest

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Bundle):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
