# coding: utf-8

"""
    Cloudera Edge Flow Manager REST API

    This REST API provides remote access to the EFM Server.                                             Endpoints that are marked as [BETA] are subject to change in future releases of the application without backwards compatibility and without a major version change.

    OpenAPI spec version: 1.0.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ELSpecification(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'specification_key': 'str',
        'operations': 'dict(str, ELOperation)'
    }

    attribute_map = {
        'specification_key': 'specificationKey',
        'operations': 'operations'
    }

    def __init__(self, specification_key=None, operations=None):
        """
        ELSpecification - a model defined in Swagger
        """

        self._specification_key = None
        self._operations = None

        if specification_key is not None:
          self.specification_key = specification_key
        if operations is not None:
          self.operations = operations

    @property
    def specification_key(self):
        """
        Gets the specification_key of this ELSpecification.
        The key for the specification in the format '<agent-type>-<version>'

        :return: The specification_key of this ELSpecification.
        :rtype: str
        """
        return self._specification_key

    @specification_key.setter
    def specification_key(self, specification_key):
        """
        Sets the specification_key of this ELSpecification.
        The key for the specification in the format '<agent-type>-<version>'

        :param specification_key: The specification_key of this ELSpecification.
        :type: str
        """

        self._specification_key = specification_key

    @property
    def operations(self):
        """
        Gets the operations of this ELSpecification.
        The available operations for the given specification where the key is the operation name

        :return: The operations of this ELSpecification.
        :rtype: dict(str, ELOperation)
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """
        Sets the operations of this ELSpecification.
        The available operations for the given specification where the key is the operation name

        :param operations: The operations of this ELSpecification.
        :type: dict(str, ELOperation)
        """

        self._operations = operations

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ELSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
