# coding: utf-8

"""
    Cloudera Edge Flow Manager REST API

    This REST API provides remote access to the EFM Server.                                             Endpoints that are marked as [BETA] are subject to change in future releases of the application without backwards compatibility and without a major version change.

    OpenAPI spec version: 1.0.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class FDComponentType(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'agent_manifest_id': 'str',
        'group': 'str',
        'artifact': 'str',
        'version': 'str',
        'type': 'str',
        'description': 'str',
        'tags': 'list[str]'
    }

    attribute_map = {
        'agent_manifest_id': 'agentManifestId',
        'group': 'group',
        'artifact': 'artifact',
        'version': 'version',
        'type': 'type',
        'description': 'description',
        'tags': 'tags'
    }

    def __init__(self, agent_manifest_id=None, group=None, artifact=None, version=None, type=None, description=None, tags=None):
        """
        FDComponentType - a model defined in Swagger
        """

        self._agent_manifest_id = None
        self._group = None
        self._artifact = None
        self._version = None
        self._type = None
        self._description = None
        self._tags = None

        if agent_manifest_id is not None:
          self.agent_manifest_id = agent_manifest_id
        if group is not None:
          self.group = group
        if artifact is not None:
          self.artifact = artifact
        if version is not None:
          self.version = version
        self.type = type
        if description is not None:
          self.description = description
        if tags is not None:
          self.tags = tags

    @property
    def agent_manifest_id(self):
        """
        Gets the agent_manifest_id of this FDComponentType.
        The id of the agent manifest this component belongs to

        :return: The agent_manifest_id of this FDComponentType.
        :rtype: str
        """
        return self._agent_manifest_id

    @agent_manifest_id.setter
    def agent_manifest_id(self, agent_manifest_id):
        """
        Sets the agent_manifest_id of this FDComponentType.
        The id of the agent manifest this component belongs to

        :param agent_manifest_id: The agent_manifest_id of this FDComponentType.
        :type: str
        """

        self._agent_manifest_id = agent_manifest_id

    @property
    def group(self):
        """
        Gets the group of this FDComponentType.
        The group name of the bundle that provides the referenced type.

        :return: The group of this FDComponentType.
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this FDComponentType.
        The group name of the bundle that provides the referenced type.

        :param group: The group of this FDComponentType.
        :type: str
        """

        self._group = group

    @property
    def artifact(self):
        """
        Gets the artifact of this FDComponentType.
        The artifact name of the bundle that provides the referenced type.

        :return: The artifact of this FDComponentType.
        :rtype: str
        """
        return self._artifact

    @artifact.setter
    def artifact(self, artifact):
        """
        Sets the artifact of this FDComponentType.
        The artifact name of the bundle that provides the referenced type.

        :param artifact: The artifact of this FDComponentType.
        :type: str
        """

        self._artifact = artifact

    @property
    def version(self):
        """
        Gets the version of this FDComponentType.
        The version of the bundle that provides the referenced type.

        :return: The version of this FDComponentType.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this FDComponentType.
        The version of the bundle that provides the referenced type.

        :param version: The version of this FDComponentType.
        :type: str
        """

        self._version = version

    @property
    def type(self):
        """
        Gets the type of this FDComponentType.
        The fully-qualified class type

        :return: The type of this FDComponentType.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this FDComponentType.
        The fully-qualified class type

        :param type: The type of this FDComponentType.
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")

        self._type = type

    @property
    def description(self):
        """
        Gets the description of this FDComponentType.
        The description for this component

        :return: The description of this FDComponentType.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this FDComponentType.
        The description for this component

        :param description: The description of this FDComponentType.
        :type: str
        """

        self._description = description

    @property
    def tags(self):
        """
        Gets the tags of this FDComponentType.
        The tags for this component

        :return: The tags of this FDComponentType.
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this FDComponentType.
        The tags for this component

        :param tags: The tags of this FDComponentType.
        :type: list[str]
        """

        self._tags = tags

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, FDComponentType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
