# coding: utf-8

"""
    Cloudera Edge Flow Manager REST API

    This REST API provides remote access to the EFM Server.                                             Endpoints that are marked as [BETA] are subject to change in future releases of the application without backwards compatibility and without a major version change.

    OpenAPI spec version: 1.0.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class FDComponentTypes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'flow_id': 'str',
        'component_types': 'list[FDComponentType]'
    }

    attribute_map = {
        'flow_id': 'flowId',
        'component_types': 'componentTypes'
    }

    def __init__(self, flow_id=None, component_types=None):
        """
        FDComponentTypes - a model defined in Swagger
        """

        self._flow_id = None
        self._component_types = None

        if flow_id is not None:
          self.flow_id = flow_id
        if component_types is not None:
          self.component_types = component_types

    @property
    def flow_id(self):
        """
        Gets the flow_id of this FDComponentTypes.
        The flow id that the component types are for

        :return: The flow_id of this FDComponentTypes.
        :rtype: str
        """
        return self._flow_id

    @flow_id.setter
    def flow_id(self, flow_id):
        """
        Sets the flow_id of this FDComponentTypes.
        The flow id that the component types are for

        :param flow_id: The flow_id of this FDComponentTypes.
        :type: str
        """

        self._flow_id = flow_id

    @property
    def component_types(self):
        """
        Gets the component_types of this FDComponentTypes.
        The set of available component types for the given flow

        :return: The component_types of this FDComponentTypes.
        :rtype: list[FDComponentType]
        """
        return self._component_types

    @component_types.setter
    def component_types(self, component_types):
        """
        Sets the component_types of this FDComponentTypes.
        The set of available component types for the given flow

        :param component_types: The component_types of this FDComponentTypes.
        :type: list[FDComponentType]
        """

        self._component_types = component_types

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, FDComponentTypes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
