# coding: utf-8

"""
    Cloudera Edge Flow Manager REST API

    This REST API provides remote access to the EFM Server.                                             Endpoints that are marked as [BETA] are subject to change in future releases of the application without backwards compatibility and without a major version change.

    OpenAPI spec version: 1.0.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PageLinks(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'first': 'Link',
        'next': 'Link',
        'prev': 'Link',
        'new': 'Link',
        'last': 'Link',
        '_self': 'Link',
        'other': 'list[Link]'
    }

    attribute_map = {
        'first': 'first',
        'next': 'next',
        'prev': 'prev',
        'new': 'new',
        'last': 'last',
        '_self': 'self',
        'other': 'other'
    }

    def __init__(self, first=None, next=None, prev=None, new=None, last=None, _self=None, other=None):
        """
        PageLinks - a model defined in Swagger
        """

        self._first = None
        self._next = None
        self._prev = None
        self._new = None
        self._last = None
        self.__self = None
        self._other = None

        if first is not None:
          self.first = first
        if next is not None:
          self.next = next
        if prev is not None:
          self.prev = prev
        if new is not None:
          self.new = new
        if last is not None:
          self.last = last
        if _self is not None:
          self._self = _self
        if other is not None:
          self.other = other

    @property
    def first(self):
        """
        Gets the first of this PageLinks.
        Link to the first page

        :return: The first of this PageLinks.
        :rtype: Link
        """
        return self._first

    @first.setter
    def first(self, first):
        """
        Sets the first of this PageLinks.
        Link to the first page

        :param first: The first of this PageLinks.
        :type: Link
        """

        self._first = first

    @property
    def next(self):
        """
        Gets the next of this PageLinks.
        Link to the next page

        :return: The next of this PageLinks.
        :rtype: Link
        """
        return self._next

    @next.setter
    def next(self, next):
        """
        Sets the next of this PageLinks.
        Link to the next page

        :param next: The next of this PageLinks.
        :type: Link
        """

        self._next = next

    @property
    def prev(self):
        """
        Gets the prev of this PageLinks.
        Link to the previous page

        :return: The prev of this PageLinks.
        :rtype: Link
        """
        return self._prev

    @prev.setter
    def prev(self, prev):
        """
        Sets the prev of this PageLinks.
        Link to the previous page

        :param prev: The prev of this PageLinks.
        :type: Link
        """

        self._prev = prev

    @property
    def new(self):
        """
        Gets the new of this PageLinks.
        Link to newer results, in the case that the resource type supports it

        :return: The new of this PageLinks.
        :rtype: Link
        """
        return self._new

    @new.setter
    def new(self, new):
        """
        Sets the new of this PageLinks.
        Link to newer results, in the case that the resource type supports it

        :param new: The new of this PageLinks.
        :type: Link
        """

        self._new = new

    @property
    def last(self):
        """
        Gets the last of this PageLinks.
        Link to the last page

        :return: The last of this PageLinks.
        :rtype: Link
        """
        return self._last

    @last.setter
    def last(self, last):
        """
        Sets the last of this PageLinks.
        Link to the last page

        :param last: The last of this PageLinks.
        :type: Link
        """

        self._last = last

    @property
    def _self(self):
        """
        Gets the _self of this PageLinks.
        Link to this resource entity

        :return: The _self of this PageLinks.
        :rtype: Link
        """
        return self.__self

    @_self.setter
    def _self(self, _self):
        """
        Sets the _self of this PageLinks.
        Link to this resource entity

        :param _self: The _self of this PageLinks.
        :type: Link
        """

        self.__self = _self

    @property
    def other(self):
        """
        Gets the other of this PageLinks.
        List of other rel links that have been set

        :return: The other of this PageLinks.
        :rtype: list[Link]
        """
        return self._other

    @other.setter
    def other(self, other):
        """
        Sets the other of this PageLinks.
        List of other rel links that have been set

        :param other: The other of this PageLinks.
        :type: list[Link]
        """

        self._other = other

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PageLinks):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
