# coding: utf-8

"""
    Cloudera Edge Flow Manager REST API

    This REST API provides remote access to the EFM Server.                                             Endpoints that are marked as [BETA] are subject to change in future releases of the application without backwards compatibility and without a major version change.

    OpenAPI spec version: 1.0.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ProcessorDefinition(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'group': 'str',
        'artifact': 'str',
        'version': 'str',
        'type': 'str',
        'type_description': 'str',
        'build_info': 'BuildInfo',
        'provided_api_implementations': 'list[DefinedType]',
        'tags': 'list[str]',
        'deprecated': 'bool',
        'deprecation_reason': 'str',
        'property_descriptors': 'dict(str, PropertyDescriptor)',
        'supports_dynamic_properties': 'bool',
        'input_requirement': 'str',
        'supported_relationships': 'list[Relationship]',
        'supports_dynamic_relationships': 'bool'
    }

    attribute_map = {
        'group': 'group',
        'artifact': 'artifact',
        'version': 'version',
        'type': 'type',
        'type_description': 'typeDescription',
        'build_info': 'buildInfo',
        'provided_api_implementations': 'providedApiImplementations',
        'tags': 'tags',
        'deprecated': 'deprecated',
        'deprecation_reason': 'deprecationReason',
        'property_descriptors': 'propertyDescriptors',
        'supports_dynamic_properties': 'supportsDynamicProperties',
        'input_requirement': 'inputRequirement',
        'supported_relationships': 'supportedRelationships',
        'supports_dynamic_relationships': 'supportsDynamicRelationships'
    }

    def __init__(self, group=None, artifact=None, version=None, type=None, type_description=None, build_info=None, provided_api_implementations=None, tags=None, deprecated=None, deprecation_reason=None, property_descriptors=None, supports_dynamic_properties=None, input_requirement=None, supported_relationships=None, supports_dynamic_relationships=None):
        """
        ProcessorDefinition - a model defined in Swagger
        """

        self._group = None
        self._artifact = None
        self._version = None
        self._type = None
        self._type_description = None
        self._build_info = None
        self._provided_api_implementations = None
        self._tags = None
        self._deprecated = None
        self._deprecation_reason = None
        self._property_descriptors = None
        self._supports_dynamic_properties = None
        self._input_requirement = None
        self._supported_relationships = None
        self._supports_dynamic_relationships = None

        if group is not None:
          self.group = group
        if artifact is not None:
          self.artifact = artifact
        if version is not None:
          self.version = version
        self.type = type
        if type_description is not None:
          self.type_description = type_description
        if build_info is not None:
          self.build_info = build_info
        if provided_api_implementations is not None:
          self.provided_api_implementations = provided_api_implementations
        if tags is not None:
          self.tags = tags
        if deprecated is not None:
          self.deprecated = deprecated
        if deprecation_reason is not None:
          self.deprecation_reason = deprecation_reason
        if property_descriptors is not None:
          self.property_descriptors = property_descriptors
        if supports_dynamic_properties is not None:
          self.supports_dynamic_properties = supports_dynamic_properties
        if input_requirement is not None:
          self.input_requirement = input_requirement
        if supported_relationships is not None:
          self.supported_relationships = supported_relationships
        if supports_dynamic_relationships is not None:
          self.supports_dynamic_relationships = supports_dynamic_relationships

    @property
    def group(self):
        """
        Gets the group of this ProcessorDefinition.
        The group name of the bundle that provides the referenced type.

        :return: The group of this ProcessorDefinition.
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this ProcessorDefinition.
        The group name of the bundle that provides the referenced type.

        :param group: The group of this ProcessorDefinition.
        :type: str
        """

        self._group = group

    @property
    def artifact(self):
        """
        Gets the artifact of this ProcessorDefinition.
        The artifact name of the bundle that provides the referenced type.

        :return: The artifact of this ProcessorDefinition.
        :rtype: str
        """
        return self._artifact

    @artifact.setter
    def artifact(self, artifact):
        """
        Sets the artifact of this ProcessorDefinition.
        The artifact name of the bundle that provides the referenced type.

        :param artifact: The artifact of this ProcessorDefinition.
        :type: str
        """

        self._artifact = artifact

    @property
    def version(self):
        """
        Gets the version of this ProcessorDefinition.
        The version of the bundle that provides the referenced type.

        :return: The version of this ProcessorDefinition.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this ProcessorDefinition.
        The version of the bundle that provides the referenced type.

        :param version: The version of this ProcessorDefinition.
        :type: str
        """

        self._version = version

    @property
    def type(self):
        """
        Gets the type of this ProcessorDefinition.
        The fully-qualified class type

        :return: The type of this ProcessorDefinition.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ProcessorDefinition.
        The fully-qualified class type

        :param type: The type of this ProcessorDefinition.
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")

        self._type = type

    @property
    def type_description(self):
        """
        Gets the type_description of this ProcessorDefinition.
        The description of the type.

        :return: The type_description of this ProcessorDefinition.
        :rtype: str
        """
        return self._type_description

    @type_description.setter
    def type_description(self, type_description):
        """
        Sets the type_description of this ProcessorDefinition.
        The description of the type.

        :param type_description: The type_description of this ProcessorDefinition.
        :type: str
        """

        self._type_description = type_description

    @property
    def build_info(self):
        """
        Gets the build_info of this ProcessorDefinition.
        The build metadata for this component

        :return: The build_info of this ProcessorDefinition.
        :rtype: BuildInfo
        """
        return self._build_info

    @build_info.setter
    def build_info(self, build_info):
        """
        Sets the build_info of this ProcessorDefinition.
        The build metadata for this component

        :param build_info: The build_info of this ProcessorDefinition.
        :type: BuildInfo
        """

        self._build_info = build_info

    @property
    def provided_api_implementations(self):
        """
        Gets the provided_api_implementations of this ProcessorDefinition.
        If this type represents a provider for an interface, this lists the APIs it implements

        :return: The provided_api_implementations of this ProcessorDefinition.
        :rtype: list[DefinedType]
        """
        return self._provided_api_implementations

    @provided_api_implementations.setter
    def provided_api_implementations(self, provided_api_implementations):
        """
        Sets the provided_api_implementations of this ProcessorDefinition.
        If this type represents a provider for an interface, this lists the APIs it implements

        :param provided_api_implementations: The provided_api_implementations of this ProcessorDefinition.
        :type: list[DefinedType]
        """

        self._provided_api_implementations = provided_api_implementations

    @property
    def tags(self):
        """
        Gets the tags of this ProcessorDefinition.
        The tags associated with this type

        :return: The tags of this ProcessorDefinition.
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this ProcessorDefinition.
        The tags associated with this type

        :param tags: The tags of this ProcessorDefinition.
        :type: list[str]
        """

        self._tags = tags

    @property
    def deprecated(self):
        """
        Gets the deprecated of this ProcessorDefinition.
        Whether or not the component has been deprecated

        :return: The deprecated of this ProcessorDefinition.
        :rtype: bool
        """
        return self._deprecated

    @deprecated.setter
    def deprecated(self, deprecated):
        """
        Sets the deprecated of this ProcessorDefinition.
        Whether or not the component has been deprecated

        :param deprecated: The deprecated of this ProcessorDefinition.
        :type: bool
        """

        self._deprecated = deprecated

    @property
    def deprecation_reason(self):
        """
        Gets the deprecation_reason of this ProcessorDefinition.
        If this component has been deprecated, this optional field can be used to provide an explanation

        :return: The deprecation_reason of this ProcessorDefinition.
        :rtype: str
        """
        return self._deprecation_reason

    @deprecation_reason.setter
    def deprecation_reason(self, deprecation_reason):
        """
        Sets the deprecation_reason of this ProcessorDefinition.
        If this component has been deprecated, this optional field can be used to provide an explanation

        :param deprecation_reason: The deprecation_reason of this ProcessorDefinition.
        :type: str
        """

        self._deprecation_reason = deprecation_reason

    @property
    def property_descriptors(self):
        """
        Gets the property_descriptors of this ProcessorDefinition.
        Descriptions of configuration properties applicable to this reporting task

        :return: The property_descriptors of this ProcessorDefinition.
        :rtype: dict(str, PropertyDescriptor)
        """
        return self._property_descriptors

    @property_descriptors.setter
    def property_descriptors(self, property_descriptors):
        """
        Sets the property_descriptors of this ProcessorDefinition.
        Descriptions of configuration properties applicable to this reporting task

        :param property_descriptors: The property_descriptors of this ProcessorDefinition.
        :type: dict(str, PropertyDescriptor)
        """

        self._property_descriptors = property_descriptors

    @property
    def supports_dynamic_properties(self):
        """
        Gets the supports_dynamic_properties of this ProcessorDefinition.
        Whether or not this processor makes use of dynamic (user-set) properties

        :return: The supports_dynamic_properties of this ProcessorDefinition.
        :rtype: bool
        """
        return self._supports_dynamic_properties

    @supports_dynamic_properties.setter
    def supports_dynamic_properties(self, supports_dynamic_properties):
        """
        Sets the supports_dynamic_properties of this ProcessorDefinition.
        Whether or not this processor makes use of dynamic (user-set) properties

        :param supports_dynamic_properties: The supports_dynamic_properties of this ProcessorDefinition.
        :type: bool
        """

        self._supports_dynamic_properties = supports_dynamic_properties

    @property
    def input_requirement(self):
        """
        Gets the input_requirement of this ProcessorDefinition.
        Any input requirements this processor has

        :return: The input_requirement of this ProcessorDefinition.
        :rtype: str
        """
        return self._input_requirement

    @input_requirement.setter
    def input_requirement(self, input_requirement):
        """
        Sets the input_requirement of this ProcessorDefinition.
        Any input requirements this processor has

        :param input_requirement: The input_requirement of this ProcessorDefinition.
        :type: str
        """
        allowed_values = ["INPUT_REQUIRED", "INPUT_ALLOWED", "INPUT_FORBIDDEN"]
        if input_requirement not in allowed_values:
            raise ValueError(
                "Invalid value for `input_requirement` ({0}), must be one of {1}"
                .format(input_requirement, allowed_values)
            )

        self._input_requirement = input_requirement

    @property
    def supported_relationships(self):
        """
        Gets the supported_relationships of this ProcessorDefinition.
        The supported relationships for this processor

        :return: The supported_relationships of this ProcessorDefinition.
        :rtype: list[Relationship]
        """
        return self._supported_relationships

    @supported_relationships.setter
    def supported_relationships(self, supported_relationships):
        """
        Sets the supported_relationships of this ProcessorDefinition.
        The supported relationships for this processor

        :param supported_relationships: The supported_relationships of this ProcessorDefinition.
        :type: list[Relationship]
        """

        self._supported_relationships = supported_relationships

    @property
    def supports_dynamic_relationships(self):
        """
        Gets the supports_dynamic_relationships of this ProcessorDefinition.
        Whether or not this processor supports dynamic relationships

        :return: The supports_dynamic_relationships of this ProcessorDefinition.
        :rtype: bool
        """
        return self._supports_dynamic_relationships

    @supports_dynamic_relationships.setter
    def supports_dynamic_relationships(self, supports_dynamic_relationships):
        """
        Sets the supports_dynamic_relationships of this ProcessorDefinition.
        Whether or not this processor supports dynamic relationships

        :param supports_dynamic_relationships: The supports_dynamic_relationships of this ProcessorDefinition.
        :type: bool
        """

        self._supports_dynamic_relationships = supports_dynamic_relationships

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ProcessorDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
